<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/miniz_oxide-0.5.3/src/inflate/mod.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>mod.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../../storage.js"></script><script defer src="../../../source-script.js"></script><script defer src="../../../source-files.js"></script><script defer src="../../../main.js"></script><noscript><link rel="stylesheet" href="../../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../../miniz_oxide/index.html"><div class="logo-container"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../../miniz_oxide/index.html"><div class="logo-container"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../../miniz_oxide/index.html"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
</pre><pre class="rust"><code><span class="doccomment">//! This module contains functionality for decompression.</span>

<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::alloc::boxed::Box</span>;
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::alloc::vec</span>;
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::alloc::vec::Vec</span>;
<span class="kw">use</span> <span class="ident">::core::cmp::min</span>;
<span class="kw">use</span> <span class="ident">::core::usize</span>;

<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">core</span>;
<span class="kw">mod</span> <span class="ident">output_buffer</span>;
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">stream</span>;
<span class="kw">use</span> <span class="ident"><span class="self">self</span>::core</span>::<span class="kw-2">*</span>;

<span class="kw">const</span> <span class="ident">TINFL_STATUS_FAILED_CANNOT_MAKE_PROGRESS</span>: <span class="ident">i32</span> <span class="op">=</span> <span class="op">-</span><span class="number">4</span>;
<span class="kw">const</span> <span class="ident">TINFL_STATUS_BAD_PARAM</span>: <span class="ident">i32</span> <span class="op">=</span> <span class="op">-</span><span class="number">3</span>;
<span class="kw">const</span> <span class="ident">TINFL_STATUS_ADLER32_MISMATCH</span>: <span class="ident">i32</span> <span class="op">=</span> <span class="op">-</span><span class="number">2</span>;
<span class="kw">const</span> <span class="ident">TINFL_STATUS_FAILED</span>: <span class="ident">i32</span> <span class="op">=</span> <span class="op">-</span><span class="number">1</span>;
<span class="kw">const</span> <span class="ident">TINFL_STATUS_DONE</span>: <span class="ident">i32</span> <span class="op">=</span> <span class="number">0</span>;
<span class="kw">const</span> <span class="ident">TINFL_STATUS_NEEDS_MORE_INPUT</span>: <span class="ident">i32</span> <span class="op">=</span> <span class="number">1</span>;
<span class="kw">const</span> <span class="ident">TINFL_STATUS_HAS_MORE_OUTPUT</span>: <span class="ident">i32</span> <span class="op">=</span> <span class="number">2</span>;

<span class="doccomment">/// Return status codes.</span>
<span class="attribute">#[<span class="ident">repr</span>(<span class="ident">i8</span>)]</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Copy</span>, <span class="ident">Clone</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Hash</span>)]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">TINFLStatus</span> {
    <span class="doccomment">/// More input data was expected, but the caller indicated that there was no more data, so the</span>
    <span class="doccomment">/// input stream is likely truncated.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This can&#39;t happen if you have provided the</span>
    <span class="doccomment">/// [`TINFL_FLAG_HAS_MORE_INPUT`][core::inflate_flags::TINFL_FLAG_HAS_MORE_INPUT] flag to the</span>
    <span class="doccomment">/// decompression.  By setting that flag, you indicate more input exists but is not provided,</span>
    <span class="doccomment">/// and so reaching the end of the input data without finding the end of the compressed stream</span>
    <span class="doccomment">/// would instead return a [`NeedsMoreInput`][Self::NeedsMoreInput] status.</span>
    <span class="ident">FailedCannotMakeProgress</span> <span class="op">=</span> <span class="ident">TINFL_STATUS_FAILED_CANNOT_MAKE_PROGRESS</span> <span class="kw">as</span> <span class="ident">i8</span>,

    <span class="doccomment">/// The output buffer is an invalid size; consider the `flags` parameter.</span>
    <span class="ident">BadParam</span> <span class="op">=</span> <span class="ident">TINFL_STATUS_BAD_PARAM</span> <span class="kw">as</span> <span class="ident">i8</span>,

    <span class="doccomment">/// The decompression went fine, but the adler32 checksum did not match the one</span>
    <span class="doccomment">/// provided in the header.</span>
    <span class="ident">Adler32Mismatch</span> <span class="op">=</span> <span class="ident">TINFL_STATUS_ADLER32_MISMATCH</span> <span class="kw">as</span> <span class="ident">i8</span>,

    <span class="doccomment">/// Failed to decompress due to invalid data.</span>
    <span class="ident">Failed</span> <span class="op">=</span> <span class="ident">TINFL_STATUS_FAILED</span> <span class="kw">as</span> <span class="ident">i8</span>,

    <span class="doccomment">/// Finished decompression without issues.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This indicates the end of the compressed stream has been reached.</span>
    <span class="ident">Done</span> <span class="op">=</span> <span class="ident">TINFL_STATUS_DONE</span> <span class="kw">as</span> <span class="ident">i8</span>,

    <span class="doccomment">/// The decompressor needs more input data to continue decompressing.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This occurs when there&#39;s no more consumable input, but the end of the stream hasn&#39;t been</span>
    <span class="doccomment">/// reached, and you have supplied the</span>
    <span class="doccomment">/// [`TINFL_FLAG_HAS_MORE_INPUT`][core::inflate_flags::TINFL_FLAG_HAS_MORE_INPUT] flag to the</span>
    <span class="doccomment">/// decompressor.  Had you not supplied that flag (which would mean you were asserting that you</span>
    <span class="doccomment">/// believed all the data was available) you would have gotten a</span>
    <span class="doccomment">/// [`FailedCannotMakeProcess`][Self::FailedCannotMakeProgress] instead.</span>
    <span class="ident">NeedsMoreInput</span> <span class="op">=</span> <span class="ident">TINFL_STATUS_NEEDS_MORE_INPUT</span> <span class="kw">as</span> <span class="ident">i8</span>,

    <span class="doccomment">/// There is still pending data that didn&#39;t fit in the output buffer.</span>
    <span class="ident">HasMoreOutput</span> <span class="op">=</span> <span class="ident">TINFL_STATUS_HAS_MORE_OUTPUT</span> <span class="kw">as</span> <span class="ident">i8</span>,
}

<span class="kw">impl</span> <span class="ident">TINFLStatus</span> {
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">from_i32</span>(<span class="ident">value</span>: <span class="ident">i32</span>) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">TINFLStatus</span><span class="op">&gt;</span> {
        <span class="kw">use</span> <span class="ident"><span class="self">self</span>::TINFLStatus</span>::<span class="kw-2">*</span>;
        <span class="kw">match</span> <span class="ident">value</span> {
            <span class="ident">TINFL_STATUS_FAILED_CANNOT_MAKE_PROGRESS</span> =&gt; <span class="prelude-val">Some</span>(<span class="ident">FailedCannotMakeProgress</span>),
            <span class="ident">TINFL_STATUS_BAD_PARAM</span> =&gt; <span class="prelude-val">Some</span>(<span class="ident">BadParam</span>),
            <span class="ident">TINFL_STATUS_ADLER32_MISMATCH</span> =&gt; <span class="prelude-val">Some</span>(<span class="ident">Adler32Mismatch</span>),
            <span class="ident">TINFL_STATUS_FAILED</span> =&gt; <span class="prelude-val">Some</span>(<span class="ident">Failed</span>),
            <span class="ident">TINFL_STATUS_DONE</span> =&gt; <span class="prelude-val">Some</span>(<span class="ident">Done</span>),
            <span class="ident">TINFL_STATUS_NEEDS_MORE_INPUT</span> =&gt; <span class="prelude-val">Some</span>(<span class="ident">NeedsMoreInput</span>),
            <span class="ident">TINFL_STATUS_HAS_MORE_OUTPUT</span> =&gt; <span class="prelude-val">Some</span>(<span class="ident">HasMoreOutput</span>),
            <span class="kw">_</span> =&gt; <span class="prelude-val">None</span>,
        }
    }
}

<span class="doccomment">/// Decompress the deflate-encoded data in `input` to a vector.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Returns a tuple of the [`Vec`] of decompressed data and the [status result][TINFLStatus].</span>
<span class="attribute">#[<span class="ident">inline</span>]</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">decompress_to_vec</span>(<span class="ident">input</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>]) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span>, <span class="ident">TINFLStatus</span><span class="op">&gt;</span> {
    <span class="ident">decompress_to_vec_inner</span>(<span class="ident">input</span>, <span class="number">0</span>, <span class="ident">usize::max_value</span>())
}

<span class="doccomment">/// Decompress the deflate-encoded data (with a zlib wrapper) in `input` to a vector.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Returns a tuple of the [`Vec`] of decompressed data and the [status result][TINFLStatus].</span>
<span class="attribute">#[<span class="ident">inline</span>]</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">decompress_to_vec_zlib</span>(<span class="ident">input</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>]) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span>, <span class="ident">TINFLStatus</span><span class="op">&gt;</span> {
    <span class="ident">decompress_to_vec_inner</span>(
        <span class="ident">input</span>,
        <span class="ident">inflate_flags::TINFL_FLAG_PARSE_ZLIB_HEADER</span>,
        <span class="ident">usize::max_value</span>(),
    )
}

<span class="doccomment">/// Decompress the deflate-encoded data in `input` to a vector.</span>
<span class="doccomment">/// The vector is grown to at most `max_size` bytes; if the data does not fit in that size,</span>
<span class="doccomment">/// [`TINFLStatus::HasMoreOutput`] error is returned.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Returns a tuple of the [`Vec`] of decompressed data and the [status result][TINFLStatus].</span>
<span class="attribute">#[<span class="ident">inline</span>]</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">decompress_to_vec_with_limit</span>(<span class="ident">input</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>], <span class="ident">max_size</span>: <span class="ident">usize</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span>, <span class="ident">TINFLStatus</span><span class="op">&gt;</span> {
    <span class="ident">decompress_to_vec_inner</span>(<span class="ident">input</span>, <span class="number">0</span>, <span class="ident">max_size</span>)
}

<span class="doccomment">/// Decompress the deflate-encoded data (with a zlib wrapper) in `input` to a vector.</span>
<span class="doccomment">/// The vector is grown to at most `max_size` bytes; if the data does not fit in that size,</span>
<span class="doccomment">/// [`TINFLStatus::HasMoreOutput`] error is returned.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Returns a tuple of the [`Vec`] of decompressed data and the [status result][TINFLStatus].</span>
<span class="attribute">#[<span class="ident">inline</span>]</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">decompress_to_vec_zlib_with_limit</span>(
    <span class="ident">input</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>],
    <span class="ident">max_size</span>: <span class="ident">usize</span>,
) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span>, <span class="ident">TINFLStatus</span><span class="op">&gt;</span> {
    <span class="ident">decompress_to_vec_inner</span>(<span class="ident">input</span>, <span class="ident">inflate_flags::TINFL_FLAG_PARSE_ZLIB_HEADER</span>, <span class="ident">max_size</span>)
}

<span class="doccomment">/// Backend of various to-[`Vec`] decompressions.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Returns a tuple of the [`Vec`] of decompressed data and the [status result][TINFLStatus].</span>
<span class="kw">fn</span> <span class="ident">decompress_to_vec_inner</span>(
    <span class="ident">input</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>],
    <span class="ident">flags</span>: <span class="ident">u32</span>,
    <span class="ident">max_output_size</span>: <span class="ident">usize</span>,
) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span>, <span class="ident">TINFLStatus</span><span class="op">&gt;</span> {
    <span class="kw">let</span> <span class="ident">flags</span> <span class="op">=</span> <span class="ident">flags</span> <span class="op">|</span> <span class="ident">inflate_flags::TINFL_FLAG_USING_NON_WRAPPING_OUTPUT_BUF</span>;
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">ret</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span> <span class="op">=</span> <span class="macro">vec!</span>[<span class="number">0</span>; <span class="ident">min</span>(<span class="ident">input</span>.<span class="ident">len</span>().<span class="ident">saturating_mul</span>(<span class="number">2</span>), <span class="ident">max_output_size</span>)];

    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">decomp</span> <span class="op">=</span> <span class="ident">Box</span>::<span class="op">&lt;</span><span class="ident">DecompressorOxide</span><span class="op">&gt;</span><span class="ident">::default</span>();

    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">in_pos</span> <span class="op">=</span> <span class="number">0</span>;
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">out_pos</span> <span class="op">=</span> <span class="number">0</span>;
    <span class="kw">loop</span> {
        <span class="comment">// Wrap the whole output slice so we know we have enough of the</span>
        <span class="comment">// decompressed data for matches.</span>
        <span class="kw">let</span> (<span class="ident">status</span>, <span class="ident">in_consumed</span>, <span class="ident">out_consumed</span>) <span class="op">=</span>
            <span class="ident">decompress</span>(<span class="kw-2">&amp;mut</span> <span class="ident">decomp</span>, <span class="kw-2">&amp;</span><span class="ident">input</span>[<span class="ident">in_pos</span>..], <span class="kw-2">&amp;mut</span> <span class="ident">ret</span>, <span class="ident">out_pos</span>, <span class="ident">flags</span>);
        <span class="ident">in_pos</span> <span class="op">+</span><span class="op">=</span> <span class="ident">in_consumed</span>;
        <span class="ident">out_pos</span> <span class="op">+</span><span class="op">=</span> <span class="ident">out_consumed</span>;

        <span class="kw">match</span> <span class="ident">status</span> {
            <span class="ident">TINFLStatus::Done</span> =&gt; {
                <span class="ident">ret</span>.<span class="ident">truncate</span>(<span class="ident">out_pos</span>);
                <span class="kw">return</span> <span class="prelude-val">Ok</span>(<span class="ident">ret</span>);
            }

            <span class="ident">TINFLStatus::HasMoreOutput</span> =&gt; {
                <span class="comment">// We need more space, so check if we can resize the buffer and do it.</span>
                <span class="kw">let</span> <span class="ident">new_len</span> <span class="op">=</span> <span class="ident">ret</span>
                    .<span class="ident">len</span>()
                    .<span class="ident">checked_add</span>(<span class="ident">out_pos</span>)
                    .<span class="ident">ok_or</span>(<span class="ident">TINFLStatus::HasMoreOutput</span>)<span class="question-mark">?</span>;
                <span class="kw">if</span> <span class="ident">new_len</span> <span class="op">&gt;</span> <span class="ident">max_output_size</span> {
                    <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="ident">TINFLStatus::HasMoreOutput</span>);
                };
                <span class="ident">ret</span>.<span class="ident">resize</span>(<span class="ident">new_len</span>, <span class="number">0</span>);
            }

            <span class="kw">_</span> =&gt; <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="ident">status</span>),
        }
    }
}

<span class="doccomment">/// Decompress one or more source slices from an iterator into the output slice.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// * On success, returns the number of bytes that were written.</span>
<span class="doccomment">/// * On failure, returns the failure status code.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This will fail if the output buffer is not large enough, but in that case</span>
<span class="doccomment">/// the output buffer will still contain the partial decompression.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// * `out` the output buffer.</span>
<span class="doccomment">/// * `it` the iterator of input slices.</span>
<span class="doccomment">/// * `zlib_header` if the first slice out of the iterator is expected to have a</span>
<span class="doccomment">///   Zlib header. Otherwise the slices are assumed to be the deflate data only.</span>
<span class="doccomment">/// * `ignore_adler32` if the adler32 checksum should be calculated or not.</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">decompress_slice_iter_to_slice</span><span class="op">&lt;</span><span class="lifetime">&#39;out</span>, <span class="lifetime">&#39;inp</span><span class="op">&gt;</span>(
    <span class="ident">out</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;out</span> <span class="kw-2">mut</span> [<span class="ident">u8</span>],
    <span class="ident">it</span>: <span class="kw">impl</span> <span class="ident">Iterator</span><span class="op">&lt;</span><span class="ident">Item</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="lifetime">&#39;inp</span> [<span class="ident">u8</span>]<span class="op">&gt;</span>,
    <span class="ident">zlib_header</span>: <span class="ident">bool</span>,
    <span class="ident">ignore_adler32</span>: <span class="ident">bool</span>,
) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">usize</span>, <span class="ident">TINFLStatus</span><span class="op">&gt;</span> {
    <span class="kw">use</span> <span class="ident"><span class="self">self</span>::core::inflate_flags</span>::<span class="kw-2">*</span>;

    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">it</span> <span class="op">=</span> <span class="ident">it</span>.<span class="ident">peekable</span>();
    <span class="kw">let</span> <span class="ident">r</span> <span class="op">=</span> <span class="kw-2">&amp;mut</span> <span class="ident">DecompressorOxide::new</span>();
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">out_pos</span> <span class="op">=</span> <span class="number">0</span>;
    <span class="kw">while</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">in_buf</span>) <span class="op">=</span> <span class="ident">it</span>.<span class="ident">next</span>() {
        <span class="kw">let</span> <span class="ident">has_more</span> <span class="op">=</span> <span class="ident">it</span>.<span class="ident">peek</span>().<span class="ident">is_some</span>();
        <span class="kw">let</span> <span class="ident">flags</span> <span class="op">=</span> {
            <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">f</span> <span class="op">=</span> <span class="ident">TINFL_FLAG_USING_NON_WRAPPING_OUTPUT_BUF</span>;
            <span class="kw">if</span> <span class="ident">zlib_header</span> {
                <span class="ident">f</span> <span class="op">|</span><span class="op">=</span> <span class="ident">TINFL_FLAG_PARSE_ZLIB_HEADER</span>;
            }
            <span class="kw">if</span> <span class="ident">ignore_adler32</span> {
                <span class="ident">f</span> <span class="op">|</span><span class="op">=</span> <span class="ident">TINFL_FLAG_IGNORE_ADLER32</span>;
            }
            <span class="kw">if</span> <span class="ident">has_more</span> {
                <span class="ident">f</span> <span class="op">|</span><span class="op">=</span> <span class="ident">TINFL_FLAG_HAS_MORE_INPUT</span>;
            }
            <span class="ident">f</span>
        };
        <span class="kw">let</span> (<span class="ident">status</span>, <span class="ident">_input_read</span>, <span class="ident">bytes_written</span>) <span class="op">=</span> <span class="ident">decompress</span>(<span class="ident">r</span>, <span class="ident">in_buf</span>, <span class="ident">out</span>, <span class="ident">out_pos</span>, <span class="ident">flags</span>);
        <span class="ident">out_pos</span> <span class="op">+</span><span class="op">=</span> <span class="ident">bytes_written</span>;
        <span class="kw">match</span> <span class="ident">status</span> {
            <span class="ident">TINFLStatus::NeedsMoreInput</span> =&gt; <span class="kw">continue</span>,
            <span class="ident">TINFLStatus::Done</span> =&gt; <span class="kw">return</span> <span class="prelude-val">Ok</span>(<span class="ident">out_pos</span>),
            <span class="ident">e</span> =&gt; <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="ident">e</span>),
        }
    }
    <span class="comment">// If we ran out of source slices without getting a `Done` from the</span>
    <span class="comment">// decompression we can call it a failure.</span>
    <span class="prelude-val">Err</span>(<span class="ident">TINFLStatus::FailedCannotMakeProgress</span>)
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">test</span>)]</span>
<span class="kw">mod</span> <span class="ident">test</span> {
    <span class="kw">use</span> <span class="kw">super</span>::{
        <span class="ident">decompress_slice_iter_to_slice</span>, <span class="ident">decompress_to_vec_zlib</span>, <span class="ident">decompress_to_vec_zlib_with_limit</span>,
        <span class="ident">TINFLStatus</span>,
    };
    <span class="kw">const</span> <span class="ident">ENCODED</span>: [<span class="ident">u8</span>; <span class="number">20</span>] <span class="op">=</span> [
        <span class="number">120</span>, <span class="number">156</span>, <span class="number">243</span>, <span class="number">72</span>, <span class="number">205</span>, <span class="number">201</span>, <span class="number">201</span>, <span class="number">215</span>, <span class="number">81</span>, <span class="number">168</span>, <span class="number">202</span>, <span class="number">201</span>, <span class="number">76</span>, <span class="number">82</span>, <span class="number">4</span>, <span class="number">0</span>, <span class="number">27</span>, <span class="number">101</span>, <span class="number">4</span>, <span class="number">19</span>,
    ];

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">decompress_vec</span>() {
        <span class="kw">let</span> <span class="ident">res</span> <span class="op">=</span> <span class="ident">decompress_to_vec_zlib</span>(<span class="kw-2">&amp;</span><span class="ident">ENCODED</span>[..]).<span class="ident">unwrap</span>();
        <span class="macro">assert_eq!</span>(<span class="ident">res</span>.<span class="ident">as_slice</span>(), <span class="kw-2">&amp;</span><span class="string">b&quot;Hello, zlib!&quot;</span>[..]);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">decompress_vec_with_high_limit</span>() {
        <span class="kw">let</span> <span class="ident">res</span> <span class="op">=</span> <span class="ident">decompress_to_vec_zlib_with_limit</span>(<span class="kw-2">&amp;</span><span class="ident">ENCODED</span>[..], <span class="number">100_000</span>).<span class="ident">unwrap</span>();
        <span class="macro">assert_eq!</span>(<span class="ident">res</span>.<span class="ident">as_slice</span>(), <span class="kw-2">&amp;</span><span class="string">b&quot;Hello, zlib!&quot;</span>[..]);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">fail_to_decompress_with_limit</span>() {
        <span class="kw">let</span> <span class="ident">res</span> <span class="op">=</span> <span class="ident">decompress_to_vec_zlib_with_limit</span>(<span class="kw-2">&amp;</span><span class="ident">ENCODED</span>[..], <span class="number">8</span>);
        <span class="kw">match</span> <span class="ident">res</span> {
            <span class="prelude-val">Err</span>(<span class="ident">TINFLStatus::HasMoreOutput</span>) =&gt; (), <span class="comment">// expected result</span>
            <span class="kw">_</span> =&gt; <span class="macro">panic!</span>(<span class="string">&quot;Decompression output size limit was not enforced&quot;</span>),
        }
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">test_decompress_slice_iter_to_slice</span>() {
        <span class="comment">// one slice</span>
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">out</span> <span class="op">=</span> [<span class="number">0_u8</span>; <span class="number">12_usize</span>];
        <span class="kw">let</span> <span class="ident">r</span> <span class="op">=</span>
            <span class="ident">decompress_slice_iter_to_slice</span>(<span class="kw-2">&amp;mut</span> <span class="ident">out</span>, <span class="prelude-val">Some</span>(<span class="kw-2">&amp;</span><span class="ident">ENCODED</span>[..]).<span class="ident">into_iter</span>(), <span class="bool-val">true</span>, <span class="bool-val">false</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">r</span>, <span class="prelude-val">Ok</span>(<span class="number">12</span>));
        <span class="macro">assert_eq!</span>(<span class="kw-2">&amp;</span><span class="ident">out</span>[..<span class="number">12</span>], <span class="kw-2">&amp;</span><span class="string">b&quot;Hello, zlib!&quot;</span>[..]);

        <span class="comment">// some chunks at a time</span>
        <span class="kw">for</span> <span class="ident">chunk_size</span> <span class="kw">in</span> <span class="number">1</span>..<span class="number">13</span> {
            <span class="comment">// Note: because of https://github.com/Frommi/miniz_oxide/issues/110 our</span>
            <span class="comment">// out buffer needs to have +1 byte available when the chunk size cuts</span>
            <span class="comment">// the adler32 data off from the last actual data.</span>
            <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">out</span> <span class="op">=</span> [<span class="number">0_u8</span>; <span class="number">12_usize</span> <span class="op">+</span> <span class="number">1</span>];
            <span class="kw">let</span> <span class="ident">r</span> <span class="op">=</span>
                <span class="ident">decompress_slice_iter_to_slice</span>(<span class="kw-2">&amp;mut</span> <span class="ident">out</span>, <span class="ident">ENCODED</span>.<span class="ident">chunks</span>(<span class="ident">chunk_size</span>), <span class="bool-val">true</span>, <span class="bool-val">false</span>);
            <span class="macro">assert_eq!</span>(<span class="ident">r</span>, <span class="prelude-val">Ok</span>(<span class="number">12</span>));
            <span class="macro">assert_eq!</span>(<span class="kw-2">&amp;</span><span class="ident">out</span>[..<span class="number">12</span>], <span class="kw-2">&amp;</span><span class="string">b&quot;Hello, zlib!&quot;</span>[..]);
        }

        <span class="comment">// output buffer too small</span>
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">out</span> <span class="op">=</span> [<span class="number">0_u8</span>; <span class="number">3_usize</span>];
        <span class="kw">let</span> <span class="ident">r</span> <span class="op">=</span> <span class="ident">decompress_slice_iter_to_slice</span>(<span class="kw-2">&amp;mut</span> <span class="ident">out</span>, <span class="ident">ENCODED</span>.<span class="ident">chunks</span>(<span class="number">7</span>), <span class="bool-val">true</span>, <span class="bool-val">false</span>);
        <span class="macro">assert!</span>(<span class="ident">r</span>.<span class="ident">is_err</span>());
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../../" data-current-crate="miniz_oxide" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>